/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "./parse.y"

/***************************************
  C Cross Referencing & Documentation tool. Version 1.6e.

  C parser.
  ******************/ /******************
  Written by Andrew M. Bishop

  This file Copyright 1995-2013 Andrew M. Bishop
  It may be distributed under the GNU Public License, version 2, or
  any higher version.  See section COPYING of the GNU Public license
  for conditions under which this file may be redistributed.
  ***************************************/

#include <string.h>
#include "parse-yy.h"
#include "cxref.h"
#include "memory.h"

/*+ A structure to hold the information about an object. +*/
typedef struct _stack
{
 char *name;                    /*+ The name of the object. +*/
 char *type;                    /*+ The type of the object. +*/
 char *qual;                    /*+ The type qualifier of the object. +*/
}
stack;

#define yylex cxref_yylex

static int cxref_yylex(void);

static void yyerror(const char *s);

/*+ When in a header file, some stuff can be skipped over quickly. +*/
extern int in_header;

/*+ A flag that is set to true when typedef is seen in a statement. +*/
int in_typedef=0;

/*+ The scope of the function / variable that is being examined. +*/
static int scope;

/*+ The variable must be LOCAL or EXTERNAL or GLOBAL, so this checks and sets that. +*/
#define SCOPE ( scope&(LOCAL|EXTERNAL|EXTERN_H|EXTERN_F) ? scope : scope|GLOBAL )

/*+ When in a function or a function definition, the behaviour is different. +*/
static int in_function=0,in_funcdef=0,in_funcbody=0;

/*+ The parsing stack +*/
static stack first={NULL,NULL,NULL},  /*+ first value. +*/
            *list=NULL,               /*+ list of all values. +*/
            *current=&first;          /*+ current values. +*/

/*+ The depth of the stack +*/
static int depth=0,             /*+ currently in use. +*/
           maxdepth=0;          /*+ total malloced. +*/

/*+ Declarations that are in the same statement share this comment. +*/
static char* common_comment=NULL;

/*+ When inside a struct / union / enum definition, this is the depth. +*/
static int in_structunion=0;

/*+ When inside a struct / union definition, this is the component type. +*/
static char *comp_type=NULL;

/*+ To solve the problem where a type name is used as an identifier. +*/
static int in_type_spec=0;


/*++++++++++++++++++++++++++++++++++++++
  Reset the current level on the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void reset(void)
{
 current->name=NULL;
 current->type=NULL;
 current->qual=NULL;
}


/*++++++++++++++++++++++++++++++++++++++
  Push a level onto the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void push(void)
{
 if(list==NULL)
   {
    list=(stack*)Malloc(8*sizeof(struct _stack));
    list[0]=first;
    maxdepth=8;
   }
 else if(depth==(maxdepth-1))
   {
    list=Realloc(list,(maxdepth+8)*sizeof(struct _stack));
    maxdepth+=8;
   }

 depth++;
 current=&list[depth];

 reset();
}


/*++++++++++++++++++++++++++++++++++++++
  Pop a level from the stack.
  ++++++++++++++++++++++++++++++++++++++*/

static void pop(void)
{
 reset();

 depth--;
 current=&list[depth];
}


/*++++++++++++++++++++++++++++++++++++++
  Reset the Parser, ready for the next file.
  ++++++++++++++++++++++++++++++++++++++*/

void ResetParser(void)
{
 in_typedef=0;
 scope=0;
 in_function=0;
 in_funcdef=0;
 in_funcbody=0;
 depth=0;
 maxdepth=0;
 if(list) Free(list);
 list=NULL;
 current=&first;
 reset();
 common_comment=NULL;
 in_structunion=0;
 comp_type=NULL;
 in_type_spec=0;
}


#line 217 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    IDENTIFIER = 258,              /* IDENTIFIER  */
    TYPE_NAME = 259,               /* TYPE_NAME  */
    LITERAL = 260,                 /* LITERAL  */
    STRING_LITERAL = 261,          /* STRING_LITERAL  */
    ELLIPSES = 262,                /* ELLIPSES  */
    MUL_ASSIGN = 263,              /* MUL_ASSIGN  */
    DIV_ASSIGN = 264,              /* DIV_ASSIGN  */
    MOD_ASSIGN = 265,              /* MOD_ASSIGN  */
    ADD_ASSIGN = 266,              /* ADD_ASSIGN  */
    SUB_ASSIGN = 267,              /* SUB_ASSIGN  */
    LEFT_ASSIGN = 268,             /* LEFT_ASSIGN  */
    RIGHT_ASSIGN = 269,            /* RIGHT_ASSIGN  */
    AND_ASSIGN = 270,              /* AND_ASSIGN  */
    XOR_ASSIGN = 271,              /* XOR_ASSIGN  */
    OR_ASSIGN = 272,               /* OR_ASSIGN  */
    EQ_OP = 273,                   /* EQ_OP  */
    NE_OP = 274,                   /* NE_OP  */
    PTR_OP = 275,                  /* PTR_OP  */
    AND_OP = 276,                  /* AND_OP  */
    OR_OP = 277,                   /* OR_OP  */
    DEC_OP = 278,                  /* DEC_OP  */
    INC_OP = 279,                  /* INC_OP  */
    LE_OP = 280,                   /* LE_OP  */
    GE_OP = 281,                   /* GE_OP  */
    LEFT_SHIFT = 282,              /* LEFT_SHIFT  */
    RIGHT_SHIFT = 283,             /* RIGHT_SHIFT  */
    SIZEOF = 284,                  /* SIZEOF  */
    TYPEDEF = 285,                 /* TYPEDEF  */
    EXTERN = 286,                  /* EXTERN  */
    STATIC = 287,                  /* STATIC  */
    AUTO = 288,                    /* AUTO  */
    REGISTER = 289,                /* REGISTER  */
    CONST = 290,                   /* CONST  */
    VOLATILE = 291,                /* VOLATILE  */
    VOID = 292,                    /* VOID  */
    INLINE = 293,                  /* INLINE  */
    CHAR = 294,                    /* CHAR  */
    SHORT = 295,                   /* SHORT  */
    INT = 296,                     /* INT  */
    LONG = 297,                    /* LONG  */
    SIGNED = 298,                  /* SIGNED  */
    UNSIGNED = 299,                /* UNSIGNED  */
    FLOAT = 300,                   /* FLOAT  */
    DOUBLE = 301,                  /* DOUBLE  */
    BOOL = 302,                    /* BOOL  */
    FLOAT_EXTENSION = 303,         /* FLOAT_EXTENSION  */
    STRUCT = 304,                  /* STRUCT  */
    UNION = 305,                   /* UNION  */
    ENUM = 306,                    /* ENUM  */
    CASE = 307,                    /* CASE  */
    DEFAULT = 308,                 /* DEFAULT  */
    IF = 309,                      /* IF  */
    ELSE = 310,                    /* ELSE  */
    SWITCH = 311,                  /* SWITCH  */
    WHILE = 312,                   /* WHILE  */
    DO = 313,                      /* DO  */
    FOR = 314,                     /* FOR  */
    GOTO = 315,                    /* GOTO  */
    CONTINUE = 316,                /* CONTINUE  */
    BREAK = 317,                   /* BREAK  */
    RETURN = 318,                  /* RETURN  */
    ASM = 319                      /* ASM  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define IDENTIFIER 258
#define TYPE_NAME 259
#define LITERAL 260
#define STRING_LITERAL 261
#define ELLIPSES 262
#define MUL_ASSIGN 263
#define DIV_ASSIGN 264
#define MOD_ASSIGN 265
#define ADD_ASSIGN 266
#define SUB_ASSIGN 267
#define LEFT_ASSIGN 268
#define RIGHT_ASSIGN 269
#define AND_ASSIGN 270
#define XOR_ASSIGN 271
#define OR_ASSIGN 272
#define EQ_OP 273
#define NE_OP 274
#define PTR_OP 275
#define AND_OP 276
#define OR_OP 277
#define DEC_OP 278
#define INC_OP 279
#define LE_OP 280
#define GE_OP 281
#define LEFT_SHIFT 282
#define RIGHT_SHIFT 283
#define SIZEOF 284
#define TYPEDEF 285
#define EXTERN 286
#define STATIC 287
#define AUTO 288
#define REGISTER 289
#define CONST 290
#define VOLATILE 291
#define VOID 292
#define INLINE 293
#define CHAR 294
#define SHORT 295
#define INT 296
#define LONG 297
#define SIGNED 298
#define UNSIGNED 299
#define FLOAT 300
#define DOUBLE 301
#define BOOL 302
#define FLOAT_EXTENSION 303
#define STRUCT 304
#define UNION 305
#define ENUM 306
#define CASE 307
#define DEFAULT 308
#define IF 309
#define ELSE 310
#define SWITCH 311
#define WHILE 312
#define DO 313
#define FOR 314
#define GOTO 315
#define CONTINUE 316
#define BREAK 317
#define RETURN 318
#define ASM 319

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENTIFIER = 3,                 /* IDENTIFIER  */
  YYSYMBOL_TYPE_NAME = 4,                  /* TYPE_NAME  */
  YYSYMBOL_LITERAL = 5,                    /* LITERAL  */
  YYSYMBOL_STRING_LITERAL = 6,             /* STRING_LITERAL  */
  YYSYMBOL_ELLIPSES = 7,                   /* ELLIPSES  */
  YYSYMBOL_MUL_ASSIGN = 8,                 /* MUL_ASSIGN  */
  YYSYMBOL_DIV_ASSIGN = 9,                 /* DIV_ASSIGN  */
  YYSYMBOL_MOD_ASSIGN = 10,                /* MOD_ASSIGN  */
  YYSYMBOL_ADD_ASSIGN = 11,                /* ADD_ASSIGN  */
  YYSYMBOL_SUB_ASSIGN = 12,                /* SUB_ASSIGN  */
  YYSYMBOL_LEFT_ASSIGN = 13,               /* LEFT_ASSIGN  */
  YYSYMBOL_RIGHT_ASSIGN = 14,              /* RIGHT_ASSIGN  */
  YYSYMBOL_AND_ASSIGN = 15,                /* AND_ASSIGN  */
  YYSYMBOL_XOR_ASSIGN = 16,                /* XOR_ASSIGN  */
  YYSYMBOL_OR_ASSIGN = 17,                 /* OR_ASSIGN  */
  YYSYMBOL_EQ_OP = 18,                     /* EQ_OP  */
  YYSYMBOL_NE_OP = 19,                     /* NE_OP  */
  YYSYMBOL_PTR_OP = 20,                    /* PTR_OP  */
  YYSYMBOL_AND_OP = 21,                    /* AND_OP  */
  YYSYMBOL_OR_OP = 22,                     /* OR_OP  */
  YYSYMBOL_DEC_OP = 23,                    /* DEC_OP  */
  YYSYMBOL_INC_OP = 24,                    /* INC_OP  */
  YYSYMBOL_LE_OP = 25,                     /* LE_OP  */
  YYSYMBOL_GE_OP = 26,                     /* GE_OP  */
  YYSYMBOL_LEFT_SHIFT = 27,                /* LEFT_SHIFT  */
  YYSYMBOL_RIGHT_SHIFT = 28,               /* RIGHT_SHIFT  */
  YYSYMBOL_SIZEOF = 29,                    /* SIZEOF  */
  YYSYMBOL_TYPEDEF = 30,                   /* TYPEDEF  */
  YYSYMBOL_EXTERN = 31,                    /* EXTERN  */
  YYSYMBOL_STATIC = 32,                    /* STATIC  */
  YYSYMBOL_AUTO = 33,                      /* AUTO  */
  YYSYMBOL_REGISTER = 34,                  /* REGISTER  */
  YYSYMBOL_CONST = 35,                     /* CONST  */
  YYSYMBOL_VOLATILE = 36,                  /* VOLATILE  */
  YYSYMBOL_VOID = 37,                      /* VOID  */
  YYSYMBOL_INLINE = 38,                    /* INLINE  */
  YYSYMBOL_CHAR = 39,                      /* CHAR  */
  YYSYMBOL_SHORT = 40,                     /* SHORT  */
  YYSYMBOL_INT = 41,                       /* INT  */
  YYSYMBOL_LONG = 42,                      /* LONG  */
  YYSYMBOL_SIGNED = 43,                    /* SIGNED  */
  YYSYMBOL_UNSIGNED = 44,                  /* UNSIGNED  */
  YYSYMBOL_FLOAT = 45,                     /* FLOAT  */
  YYSYMBOL_DOUBLE = 46,                    /* DOUBLE  */
  YYSYMBOL_BOOL = 47,                      /* BOOL  */
  YYSYMBOL_FLOAT_EXTENSION = 48,           /* FLOAT_EXTENSION  */
  YYSYMBOL_STRUCT = 49,                    /* STRUCT  */
  YYSYMBOL_UNION = 50,                     /* UNION  */
  YYSYMBOL_ENUM = 51,                      /* ENUM  */
  YYSYMBOL_CASE = 52,                      /* CASE  */
  YYSYMBOL_DEFAULT = 53,                   /* DEFAULT  */
  YYSYMBOL_IF = 54,                        /* IF  */
  YYSYMBOL_ELSE = 55,                      /* ELSE  */
  YYSYMBOL_SWITCH = 56,                    /* SWITCH  */
  YYSYMBOL_WHILE = 57,                     /* WHILE  */
  YYSYMBOL_DO = 58,                        /* DO  */
  YYSYMBOL_FOR = 59,                       /* FOR  */
  YYSYMBOL_GOTO = 60,                      /* GOTO  */
  YYSYMBOL_CONTINUE = 61,                  /* CONTINUE  */
  YYSYMBOL_BREAK = 62,                     /* BREAK  */
  YYSYMBOL_RETURN = 63,                    /* RETURN  */
  YYSYMBOL_ASM = 64,                       /* ASM  */
  YYSYMBOL_65_ = 65,                       /* ';'  */
  YYSYMBOL_66_ = 66,                       /* ','  */
  YYSYMBOL_67_ = 67,                       /* '='  */
  YYSYMBOL_68_ = 68,                       /* '{'  */
  YYSYMBOL_69_ = 69,                       /* '}'  */
  YYSYMBOL_70_ = 70,                       /* ':'  */
  YYSYMBOL_71_ = 71,                       /* '.'  */
  YYSYMBOL_72_ = 72,                       /* '['  */
  YYSYMBOL_73_ = 73,                       /* ']'  */
  YYSYMBOL_74_ = 74,                       /* '('  */
  YYSYMBOL_75_ = 75,                       /* ')'  */
  YYSYMBOL_76_ = 76,                       /* '*'  */
  YYSYMBOL_77_ = 77,                       /* '?'  */
  YYSYMBOL_78_ = 78,                       /* '|'  */
  YYSYMBOL_79_ = 79,                       /* '^'  */
  YYSYMBOL_80_ = 80,                       /* '&'  */
  YYSYMBOL_81_ = 81,                       /* '<'  */
  YYSYMBOL_82_ = 82,                       /* '>'  */
  YYSYMBOL_83_ = 83,                       /* '+'  */
  YYSYMBOL_84_ = 84,                       /* '-'  */
  YYSYMBOL_85_ = 85,                       /* '/'  */
  YYSYMBOL_86_ = 86,                       /* '%'  */
  YYSYMBOL_87_ = 87,                       /* '~'  */
  YYSYMBOL_88_ = 88,                       /* '!'  */
  YYSYMBOL_YYACCEPT = 89,                  /* $accept  */
  YYSYMBOL_file = 90,                      /* file  */
  YYSYMBOL_program = 91,                   /* program  */
  YYSYMBOL_top_level_declaration = 92,     /* top_level_declaration  */
  YYSYMBOL_declaration_list = 93,          /* declaration_list  */
  YYSYMBOL_declaration = 94,               /* declaration  */
  YYSYMBOL_declaration_specifiers = 95,    /* declaration_specifiers  */
  YYSYMBOL_declaration_specifiers1 = 96,   /* declaration_specifiers1  */
  YYSYMBOL_initialized_declarator_list = 97, /* initialized_declarator_list  */
  YYSYMBOL_98_1 = 98,                      /* $@1  */
  YYSYMBOL_initialized_declarator = 99,    /* initialized_declarator  */
  YYSYMBOL_initialized_declarator1 = 100,  /* initialized_declarator1  */
  YYSYMBOL_initializer_part = 101,         /* initializer_part  */
  YYSYMBOL_initializer = 102,              /* initializer  */
  YYSYMBOL_struct_initializer_list = 103,  /* struct_initializer_list  */
  YYSYMBOL_named_initializer = 104,        /* named_initializer  */
  YYSYMBOL_designator = 105,               /* designator  */
  YYSYMBOL_designator_list = 106,          /* designator_list  */
  YYSYMBOL_named_initializer_index = 107,  /* named_initializer_index  */
  YYSYMBOL_abstract_declarator = 108,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 109, /* direct_abstract_declarator  */
  YYSYMBOL_declarator = 110,               /* declarator  */
  YYSYMBOL_pointer = 111,                  /* pointer  */
  YYSYMBOL_direct_declarator = 112,        /* direct_declarator  */
  YYSYMBOL_simple_declarator = 113,        /* simple_declarator  */
  YYSYMBOL_array_declarator = 114,         /* array_declarator  */
  YYSYMBOL_115_2 = 115,                    /* $@2  */
  YYSYMBOL_116_3 = 116,                    /* $@3  */
  YYSYMBOL_name = 117,                     /* name  */
  YYSYMBOL_storage_class_specifier = 118,  /* storage_class_specifier  */
  YYSYMBOL_type_qualifier_list = 119,      /* type_qualifier_list  */
  YYSYMBOL_type_qualifier = 120,           /* type_qualifier  */
  YYSYMBOL_type_specifier = 121,           /* type_specifier  */
  YYSYMBOL_type_specifier1 = 122,          /* type_specifier1  */
  YYSYMBOL_floating_type_specifier = 123,  /* floating_type_specifier  */
  YYSYMBOL_integer_type_specifier = 124,   /* integer_type_specifier  */
  YYSYMBOL_integer_type_specifier_part = 125, /* integer_type_specifier_part  */
  YYSYMBOL_boolean_type_specifier = 126,   /* boolean_type_specifier  */
  YYSYMBOL_typedef_name = 127,             /* typedef_name  */
  YYSYMBOL_void_type_specifier = 128,      /* void_type_specifier  */
  YYSYMBOL_type_name = 129,                /* type_name  */
  YYSYMBOL_enumeration_type_specifier = 130, /* enumeration_type_specifier  */
  YYSYMBOL_enumeration_type_definition = 131, /* enumeration_type_definition  */
  YYSYMBOL_132_4 = 132,                    /* $@4  */
  YYSYMBOL_133_5 = 133,                    /* $@5  */
  YYSYMBOL_enumeration_definition_list = 134, /* enumeration_definition_list  */
  YYSYMBOL_enumeration_definition_list1 = 135, /* enumeration_definition_list1  */
  YYSYMBOL_enumeration_constant_definition = 136, /* enumeration_constant_definition  */
  YYSYMBOL_enumeration_constant = 137,     /* enumeration_constant  */
  YYSYMBOL_enumeration_type_reference = 138, /* enumeration_type_reference  */
  YYSYMBOL_enumeration_tag = 139,          /* enumeration_tag  */
  YYSYMBOL_structure_type_specifier = 140, /* structure_type_specifier  */
  YYSYMBOL_structure_type_definition = 141, /* structure_type_definition  */
  YYSYMBOL_142_6 = 142,                    /* $@6  */
  YYSYMBOL_143_7 = 143,                    /* $@7  */
  YYSYMBOL_structure_type_reference = 144, /* structure_type_reference  */
  YYSYMBOL_structure_tag = 145,            /* structure_tag  */
  YYSYMBOL_union_type_specifier = 146,     /* union_type_specifier  */
  YYSYMBOL_union_type_definition = 147,    /* union_type_definition  */
  YYSYMBOL_148_8 = 148,                    /* $@8  */
  YYSYMBOL_149_9 = 149,                    /* $@9  */
  YYSYMBOL_union_type_reference = 150,     /* union_type_reference  */
  YYSYMBOL_union_tag = 151,                /* union_tag  */
  YYSYMBOL_field_list = 152,               /* field_list  */
  YYSYMBOL_field_list1 = 153,              /* field_list1  */
  YYSYMBOL_field_list2 = 154,              /* field_list2  */
  YYSYMBOL_component_declaration = 155,    /* component_declaration  */
  YYSYMBOL_156_10 = 156,                   /* $@10  */
  YYSYMBOL_157_11 = 157,                   /* $@11  */
  YYSYMBOL_158_12 = 158,                   /* $@12  */
  YYSYMBOL_component_declarator_list = 159, /* component_declarator_list  */
  YYSYMBOL_component_declarator = 160,     /* component_declarator  */
  YYSYMBOL_simple_component = 161,         /* simple_component  */
  YYSYMBOL_bit_field = 162,                /* bit_field  */
  YYSYMBOL_width = 163,                    /* width  */
  YYSYMBOL_component_name = 164,           /* component_name  */
  YYSYMBOL_function_definition = 165,      /* function_definition  */
  YYSYMBOL_166_13 = 166,                   /* $@13  */
  YYSYMBOL_function_specifier = 167,       /* function_specifier  */
  YYSYMBOL_function_specifier1 = 168,      /* function_specifier1  */
  YYSYMBOL_function_declarator = 169,      /* function_declarator  */
  YYSYMBOL_function_declarator0 = 170,     /* function_declarator0  */
  YYSYMBOL_function_direct_declarator = 171, /* function_direct_declarator  */
  YYSYMBOL_172_14 = 172,                   /* $@14  */
  YYSYMBOL_function_declarator1 = 173,     /* function_declarator1  */
  YYSYMBOL_function_declarator2 = 174,     /* function_declarator2  */
  YYSYMBOL_identifier_list = 175,          /* identifier_list  */
  YYSYMBOL_parameter_type_list = 176,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 177,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 178,    /* parameter_declaration  */
  YYSYMBOL_statement = 179,                /* statement  */
  YYSYMBOL_compound_statement = 180,       /* compound_statement  */
  YYSYMBOL_181_15 = 181,                   /* $@15  */
  YYSYMBOL_182_16 = 182,                   /* $@16  */
  YYSYMBOL_compound_statement_body = 183,  /* compound_statement_body  */
  YYSYMBOL_block_item_list = 184,          /* block_item_list  */
  YYSYMBOL_block_item = 185,               /* block_item  */
  YYSYMBOL_conditional_statement = 186,    /* conditional_statement  */
  YYSYMBOL_if_else_statement = 187,        /* if_else_statement  */
  YYSYMBOL_if_statement = 188,             /* if_statement  */
  YYSYMBOL_iterative_statement = 189,      /* iterative_statement  */
  YYSYMBOL_do_statement = 190,             /* do_statement  */
  YYSYMBOL_for_statement = 191,            /* for_statement  */
  YYSYMBOL_192_17 = 192,                   /* $@17  */
  YYSYMBOL_for_expressions = 193,          /* for_expressions  */
  YYSYMBOL_for_expression_or_declaration = 194, /* for_expression_or_declaration  */
  YYSYMBOL_while_statement = 195,          /* while_statement  */
  YYSYMBOL_labeled_statement = 196,        /* labeled_statement  */
  YYSYMBOL_case_label = 197,               /* case_label  */
  YYSYMBOL_default_label = 198,            /* default_label  */
  YYSYMBOL_named_label = 199,              /* named_label  */
  YYSYMBOL_switch_statement = 200,         /* switch_statement  */
  YYSYMBOL_break_statement = 201,          /* break_statement  */
  YYSYMBOL_continue_statement = 202,       /* continue_statement  */
  YYSYMBOL_expression_statement = 203,     /* expression_statement  */
  YYSYMBOL_goto_statement = 204,           /* goto_statement  */
  YYSYMBOL_null_statement = 205,           /* null_statement  */
  YYSYMBOL_return_statement = 206,         /* return_statement  */
  YYSYMBOL_expression = 207,               /* expression  */
  YYSYMBOL_comma_expression = 208,         /* comma_expression  */
  YYSYMBOL_assignment_expression = 209,    /* assignment_expression  */
  YYSYMBOL_assignment_op = 210,            /* assignment_op  */
  YYSYMBOL_conditional_expression = 211,   /* conditional_expression  */
  YYSYMBOL_logical_or_expression = 212,    /* logical_or_expression  */
  YYSYMBOL_logical_and_expression = 213,   /* logical_and_expression  */
  YYSYMBOL_bitwise_or_expression = 214,    /* bitwise_or_expression  */
  YYSYMBOL_bitwise_xor_expression = 215,   /* bitwise_xor_expression  */
  YYSYMBOL_bitwise_and_expression = 216,   /* bitwise_and_expression  */
  YYSYMBOL_equality_expression = 217,      /* equality_expression  */
  YYSYMBOL_equality_op = 218,              /* equality_op  */
  YYSYMBOL_relational_expression = 219,    /* relational_expression  */
  YYSYMBOL_relational_op = 220,            /* relational_op  */
  YYSYMBOL_shift_expression = 221,         /* shift_expression  */
  YYSYMBOL_shift_op = 222,                 /* shift_op  */
  YYSYMBOL_additive_expression = 223,      /* additive_expression  */
  YYSYMBOL_add_op = 224,                   /* add_op  */
  YYSYMBOL_multiplicative_expression = 225, /* multiplicative_expression  */
  YYSYMBOL_mult_op = 226,                  /* mult_op  */
  YYSYMBOL_unary_expression = 227,         /* unary_expression  */
  YYSYMBOL_address_expression = 228,       /* address_expression  */
  YYSYMBOL_bitwise_negation_expression = 229, /* bitwise_negation_expression  */
  YYSYMBOL_cast_expression = 230,          /* cast_expression  */
  YYSYMBOL_indirection_expression = 231,   /* indirection_expression  */
  YYSYMBOL_logical_negation_expression = 232, /* logical_negation_expression  */
  YYSYMBOL_predecrement_expression = 233,  /* predecrement_expression  */
  YYSYMBOL_preincrement_expression = 234,  /* preincrement_expression  */
  YYSYMBOL_sizeof_expression = 235,        /* sizeof_expression  */
  YYSYMBOL_unary_minus_expression = 236,   /* unary_minus_expression  */
  YYSYMBOL_unary_plus_expression = 237,    /* unary_plus_expression  */
  YYSYMBOL_postfix_expression = 238,       /* postfix_expression  */
  YYSYMBOL_component_selection_expression = 239, /* component_selection_expression  */
  YYSYMBOL_direct_component_selection = 240, /* direct_component_selection  */
  YYSYMBOL_indirect_component_selection = 241, /* indirect_component_selection  */
  YYSYMBOL_function_call = 242,            /* function_call  */
  YYSYMBOL_function_call_direct = 243,     /* function_call_direct  */
  YYSYMBOL_postdecrement_expression = 244, /* postdecrement_expression  */
  YYSYMBOL_postincrement_expression = 245, /* postincrement_expression  */
  YYSYMBOL_subscript_expression = 246,     /* subscript_expression  */
  YYSYMBOL_primary_expression = 247,       /* primary_expression  */
  YYSYMBOL_string_literal = 248,           /* string_literal  */
  YYSYMBOL_parenthesized_expression = 249, /* parenthesized_expression  */
  YYSYMBOL_250_18 = 250,                   /* $@18  */
  YYSYMBOL_251_19 = 251,                   /* $@19  */
  YYSYMBOL_constant_expression = 252,      /* constant_expression  */
  YYSYMBOL_expression_list = 253,          /* expression_list  */
  YYSYMBOL_asm_statement = 254,            /* asm_statement  */
  YYSYMBOL_asm_type = 255,                 /* asm_type  */
  YYSYMBOL_asm_inout_list = 256,           /* asm_inout_list  */
  YYSYMBOL_asm_inout = 257,                /* asm_inout  */
  YYSYMBOL_asm_clobber_list = 258,         /* asm_clobber_list  */
  YYSYMBOL_asm_label = 259,                /* asm_label  */
  YYSYMBOL_named_label_address = 260       /* named_label_address  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  93
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1562

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  89
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  172
/* YYNRULES -- Number of rules.  */
#define YYNRULES  380
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  573

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   319


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    88,     2,     2,     2,    86,    80,     2,
      74,    75,    76,    83,    66,    84,    71,    85,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    70,    65,
      81,    67,    82,    77,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    72,     2,    73,    79,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    68,    78,    69,    87,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   167,   167,   168,   172,   173,   177,   179,   181,   182,
     188,   190,   196,   198,   203,   209,   210,   212,   214,   217,
     218,   225,   226,   226,   230,   274,   275,   276,   277,   281,
     285,   286,   290,   291,   292,   293,   297,   298,   299,   303,
     304,   308,   309,   313,   314,   320,   321,   323,   327,   330,
     332,   334,   336,   338,   340,   342,   344,   351,   353,   358,
     359,   361,   363,   368,   369,   373,   374,   378,   385,   387,
     387,   387,   394,   398,   400,   405,   407,   409,   413,   418,
     419,   424,   426,   433,   438,   439,   440,   441,   442,   443,
     444,   445,   449,   450,   451,   452,   454,   459,   460,   462,
     467,   468,   469,   470,   471,   472,   476,   480,   484,   488,
     490,   497,   498,   503,   502,   516,   515,   531,   532,   536,
     537,   542,   544,   549,   553,   558,   559,   565,   566,   571,
     570,   584,   583,   599,   604,   605,   611,   612,   617,   616,
     630,   629,   645,   650,   651,   657,   658,   662,   663,   668,
     669,   672,   675,   680,   679,   684,   683,   688,   687,   694,
     696,   702,   703,   707,   712,   714,   719,   723,   724,   733,
     732,   739,   762,   763,   765,   766,   773,   778,   779,   780,
     782,   788,   787,   798,   807,   809,   810,   814,   816,   822,
     823,   829,   832,   838,   840,   842,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   867,   869,
     866,   874,   875,   879,   880,   884,   885,   892,   893,   897,
     901,   907,   908,   909,   913,   918,   917,   924,   925,   926,
     927,   928,   929,   930,   931,   935,   936,   938,   943,   949,
     950,   951,   955,   956,   960,   964,   965,   971,   977,   981,
     985,   989,   993,   997,   998,  1004,  1010,  1011,  1018,  1019,
    1020,  1021,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1041,  1042,  1044,  1051,  1052,  1059,  1060,
    1067,  1068,  1075,  1076,  1083,  1084,  1091,  1092,  1097,  1098,
    1104,  1105,  1110,  1111,  1112,  1113,  1119,  1120,  1125,  1126,
    1132,  1133,  1138,  1139,  1145,  1146,  1151,  1152,  1153,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,  1168,  1169,
    1173,  1177,  1182,  1184,  1188,  1192,  1197,  1201,  1205,  1207,
    1212,  1217,  1224,  1225,  1226,  1228,  1229,  1230,  1231,  1235,
    1236,  1240,  1244,  1248,  1249,  1253,  1254,  1258,  1262,  1266,
    1270,  1272,  1273,  1274,  1278,  1279,  1283,  1285,  1285,  1285,
    1291,  1295,  1296,  1304,  1305,  1306,  1307,  1311,  1312,  1313,
    1317,  1318,  1319,  1323,  1324,  1325,  1329,  1330,  1331,  1335,
    1341
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENTIFIER",
  "TYPE_NAME", "LITERAL", "STRING_LITERAL", "ELLIPSES", "MUL_ASSIGN",
  "DIV_ASSIGN", "MOD_ASSIGN", "ADD_ASSIGN", "SUB_ASSIGN", "LEFT_ASSIGN",
  "RIGHT_ASSIGN", "AND_ASSIGN", "XOR_ASSIGN", "OR_ASSIGN", "EQ_OP",
  "NE_OP", "PTR_OP", "AND_OP", "OR_OP", "DEC_OP", "INC_OP", "LE_OP",
  "GE_OP", "LEFT_SHIFT", "RIGHT_SHIFT", "SIZEOF", "TYPEDEF", "EXTERN",
  "STATIC", "AUTO", "REGISTER", "CONST", "VOLATILE", "VOID", "INLINE",
  "CHAR", "SHORT", "INT", "LONG", "SIGNED", "UNSIGNED", "FLOAT", "DOUBLE",
  "BOOL", "FLOAT_EXTENSION", "STRUCT", "UNION", "ENUM", "CASE", "DEFAULT",
  "IF", "ELSE", "SWITCH", "WHILE", "DO", "FOR", "GOTO", "CONTINUE",
  "BREAK", "RETURN", "ASM", "';'", "','", "'='", "'{'", "'}'", "':'",
  "'.'", "'['", "']'", "'('", "')'", "'*'", "'?'", "'|'", "'^'", "'&'",
  "'<'", "'>'", "'+'", "'-'", "'/'", "'%'", "'~'", "'!'", "$accept",
  "file", "program", "top_level_declaration", "declaration_list",
  "declaration", "declaration_specifiers", "declaration_specifiers1",
  "initialized_declarator_list", "$@1", "initialized_declarator",
  "initialized_declarator1", "initializer_part", "initializer",
  "struct_initializer_list", "named_initializer", "designator",
  "designator_list", "named_initializer_index", "abstract_declarator",
  "direct_abstract_declarator", "declarator", "pointer",
  "direct_declarator", "simple_declarator", "array_declarator", "$@2",
  "$@3", "name", "storage_class_specifier", "type_qualifier_list",
  "type_qualifier", "type_specifier", "type_specifier1",
  "floating_type_specifier", "integer_type_specifier",
  "integer_type_specifier_part", "boolean_type_specifier", "typedef_name",
  "void_type_specifier", "type_name", "enumeration_type_specifier",
  "enumeration_type_definition", "$@4", "$@5",
  "enumeration_definition_list", "enumeration_definition_list1",
  "enumeration_constant_definition", "enumeration_constant",
  "enumeration_type_reference", "enumeration_tag",
  "structure_type_specifier", "structure_type_definition", "$@6", "$@7",
  "structure_type_reference", "structure_tag", "union_type_specifier",
  "union_type_definition", "$@8", "$@9", "union_type_reference",
  "union_tag", "field_list", "field_list1", "field_list2",
  "component_declaration", "$@10", "$@11", "$@12",
  "component_declarator_list", "component_declarator", "simple_component",
  "bit_field", "width", "component_name", "function_definition", "$@13",
  "function_specifier", "function_specifier1", "function_declarator",
  "function_declarator0", "function_direct_declarator", "$@14",
  "function_declarator1", "function_declarator2", "identifier_list",
  "parameter_type_list", "parameter_list", "parameter_declaration",
  "statement", "compound_statement", "$@15", "$@16",
  "compound_statement_body", "block_item_list", "block_item",
  "conditional_statement", "if_else_statement", "if_statement",
  "iterative_statement", "do_statement", "for_statement", "$@17",
  "for_expressions", "for_expression_or_declaration", "while_statement",
  "labeled_statement", "case_label", "default_label", "named_label",
  "switch_statement", "break_statement", "continue_statement",
  "expression_statement", "goto_statement", "null_statement",
  "return_statement", "expression", "comma_expression",
  "assignment_expression", "assignment_op", "conditional_expression",
  "logical_or_expression", "logical_and_expression",
  "bitwise_or_expression", "bitwise_xor_expression",
  "bitwise_and_expression", "equality_expression", "equality_op",
  "relational_expression", "relational_op", "shift_expression", "shift_op",
  "additive_expression", "add_op", "multiplicative_expression", "mult_op",
  "unary_expression", "address_expression", "bitwise_negation_expression",
  "cast_expression", "indirection_expression",
  "logical_negation_expression", "predecrement_expression",
  "preincrement_expression", "sizeof_expression", "unary_minus_expression",
  "unary_plus_expression", "postfix_expression",
  "component_selection_expression", "direct_component_selection",
  "indirect_component_selection", "function_call", "function_call_direct",
  "postdecrement_expression", "postincrement_expression",
  "subscript_expression", "primary_expression", "string_literal",
  "parenthesized_expression", "$@18", "$@19", "constant_expression",
  "expression_list", "asm_statement", "asm_type", "asm_inout_list",
  "asm_inout", "asm_clobber_list", "asm_label", "named_label_address", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-404)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-247)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1247,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,   -27,
    -404,  -404,  -404,  -404,  -404,    14,  -404,  -404,  -404,    34,
    -404,  -404,    59,    76,   117,   115,  -404,    22,    80,   112,
    1247,  -404,  -404,    12,  -404,    18,    94,  -404,  -404,  1511,
    1511,  1511,  -404,  -404,   291,     8,  -404,  -404,  -404,  -404,
    -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,
    -404,  1511,  -404,   242,    81,  -404,  -404,    95,  -404,  -404,
    -404,  -404,  -404,  -404,   109,  -404,  -404,  -404,   126,  -404,
    -404,  -404,   137,  -404,    22,   107,    32,    61,   139,  -404,
    -404,    80,  -404,  -404,  -404,  -404,   146,  -404,  -404,   -44,
      18,  1511,    22,   242,   160,  -404,  -404,  -404,  -404,  -404,
    -404,   158,  1511,  -404,    13,  -404,   232,   852,  -404,   852,
    -404,   255,  -404,  -404,  -404,    61,  -404,  -404,  -404,  -404,
    -404,   191,   299,  -404,   202,  1511,   199,  -404,  1124,  -404,
    -404,  -404,  1441,  -404,    35,  -404,   946,     8,   222,   228,
     226,   852,  -404,  -404,   852,   234,   852,  -404,   241,   249,
    -404,   260,   255,    22,   232,  -404,  -404,   258,  1161,  1161,
    1186,   192,   599,  1161,  1161,  1161,  1161,  1161,  1161,  -404,
     263,  -404,  -404,    77,   320,   261,   268,   270,   259,    82,
     318,   229,   114,   231,  -404,  -404,  -404,  -404,  -404,  -404,
    -404,  -404,  -404,  -404,   211,  -404,  -404,  -404,  -404,  -404,
    -404,  -404,  -404,  -404,   354,  -404,  -404,  -404,  -404,  -404,
     298,  -404,  -404,   427,  -404,     9,   297,   300,  -404,   308,
    -404,  -404,    52,   313,  -404,     8,    21,  -404,  -404,  -404,
    -404,   316,  -404,   319,  -404,   255,  1124,   325,  -404,    36,
    -404,  -404,  -404,  -404,  -404,   599,  -404,   314,  -404,   315,
    1124,  -404,   122,  -404,  -404,   153,   326,   264,   322,   323,
     158,  -404,  -404,  -404,  -404,  -404,  -404,   720,  1161,   742,
    1161,  1161,  1161,  1161,  -404,  -404,  1161,  -404,  -404,  -404,
    -404,  1161,  -404,  -404,  1161,  -404,  -404,  1161,  -404,  -404,
    -404,  1161,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,
    -404,  -404,  -404,   764,   315,  -404,  -404,   315,  1124,   836,
    1124,   327,   331,   333,  1124,  -404,   321,   330,   332,   648,
    -404,   386,   340,   342,   861,  -404,  -404,  -404,  -404,   427,
    -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,   338,
     339,   341,  -404,  -404,  -404,  -404,  -404,  -404,  -404,   347,
    -404,   933,  1296,  -404,    74,  -404,    29,  -404,   410,  1489,
     349,    39,    83,  -404,  -404,    21,    21,  1124,   348,   289,
    -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,   344,
    -404,  -404,   351,   413,   192,  -404,   299,  -404,   299,  1344,
    -404,   218,  1146,  -404,  -404,  -404,  -404,   -49,   320,  -404,
    1161,   352,   261,   268,   270,   259,    82,   318,   229,   114,
    -404,   192,  -404,  -404,  -404,   353,  -404,    51,  -404,  -404,
     420,  1124,  1124,  1124,   -27,   360,   355,   363,  -404,  -404,
    -404,   369,   367,  -404,  -404,  -404,  -404,  -404,  -404,   364,
    -404,   365,   366,   955,  1392,    74,  -404,  -404,  -404,   370,
     371,  1124,    52,    52,   373,   292,   311,  -404,  -404,  1124,
    -404,    21,  1146,  -404,  1124,  -404,  -404,  -404,   192,  -404,
     374,  1124,  -404,  -404,  1161,   183,  -404,  -404,  1124,   377,
     378,   380,   368,   513,  -404,  -404,  -404,  -404,  -404,  -404,
    -404,   372,  -404,   407,   232,   232,   421,  -404,   157,  -404,
    -404,  -404,  -404,  -404,  -404,   184,  -404,  -404,  -404,  -404,
    -404,   648,   648,   648,  1124,  1027,    22,   422,   381,  -404,
    -404,  -404,    40,    45,  -404,   232,   433,  -404,   444,  -404,
    -404,   425,  1124,   437,   438,   648,  1052,  1124,  1124,   354,
     108,  -404,   648,   440,  -404,  1124,  -404,  1124,   441,   434,
     445,   232,   443,  -404,  -404,  -404,  -404,  1124,  -404,  -404,
     354,  -404,  -404
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,    67,   107,    77,    74,    76,    73,    75,    81,    82,
     108,    78,   102,   103,   104,   105,   100,   101,    92,    93,
     106,    94,     0,     0,     0,   367,   252,     0,    59,     0,
       3,     4,     6,     0,    14,     0,   183,    63,    65,    15,
      19,    17,    83,    85,    86,    97,    87,    89,    91,    84,
     111,   112,    88,   127,   128,    90,   136,   137,     7,   169,
     171,   172,   176,   177,     0,     9,     8,     0,   369,    96,
      95,   134,   135,   129,   133,   143,   144,   138,   142,   125,
     126,   113,   124,   368,     0,     0,     0,    57,    66,    82,
      61,    60,    79,     1,     5,    13,     0,    21,    24,    25,
       0,   173,     0,   179,    69,    16,    20,    18,   105,    99,
      98,     0,   174,    10,     0,   181,     0,   145,   131,   145,
     140,     0,   115,    66,    64,    58,   178,    62,    80,    12,
      22,     0,     0,    27,    26,   175,    66,    68,     0,   208,
     170,    11,   184,   354,     0,   149,     0,   153,   127,   136,
       0,   146,   147,   152,   145,     0,   145,   123,     0,   117,
     119,   121,     0,     0,     0,    72,   351,     0,     0,     0,
       0,    32,   357,     0,     0,     0,     0,     0,     0,    29,
     350,    30,   258,   273,   276,   278,   280,   282,   284,   286,
     290,   296,   300,   304,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   332,   339,   340,   333,   334,
     335,   336,   337,   338,   352,   353,   259,    28,   180,   360,
     255,   256,    70,   211,   187,   194,     0,   186,   185,   189,
     191,   355,   370,     0,   155,   157,     0,   150,   151,   130,
     148,     0,   139,     0,   114,   118,     0,     0,    23,     0,
     245,   246,   380,   326,   327,   357,   329,    72,   168,     0,
       0,    36,     0,    33,    41,     0,     0,   109,     0,     0,
       0,   324,   320,   331,   330,   321,   325,     0,     0,     0,
       0,     0,     0,     0,   288,   289,     0,   293,   295,   292,
     294,     0,   298,   299,     0,   302,   303,     0,   306,   307,
     308,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   262,     0,     0,   347,   348,     0,     0,     0,
       0,     0,    72,   107,     0,   244,     0,     0,     0,     0,
     225,     0,     0,     0,     0,   216,   215,   197,   209,   212,
     213,   198,   218,   217,   199,   221,   222,   223,   200,     0,
       0,     0,   201,   202,   203,   204,   205,   206,   207,     0,
     196,     0,     0,   195,    47,   193,    45,   182,     0,     0,
       0,     0,     0,   371,   363,     0,     0,     0,   163,     0,
     159,   161,   162,   132,   141,   120,   122,   116,   379,     0,
     167,    39,     0,    43,    35,    31,     0,    42,     0,     0,
     110,    45,     0,   356,   358,   345,   361,     0,   277,   304,
       0,     0,   279,   281,   283,   285,   287,   291,   297,   301,
     305,    32,   260,   342,   341,     0,   343,     0,   257,    71,
     242,     0,     0,     0,     0,     0,     0,     0,   249,   248,
     253,     0,     0,   214,   239,   241,   240,   250,    49,     0,
      53,     0,     0,     0,     0,    46,   188,   190,   192,     0,
       0,     0,     0,   370,     0,     0,     0,   164,   166,     0,
     154,     0,   328,    40,     0,    34,    38,    37,    32,   322,
       0,     0,   346,   275,     0,     0,   349,   344,     0,     0,
       0,     0,     0,     0,   251,   254,   210,    51,    48,    55,
      50,     0,    54,     0,     0,     0,     0,   372,     0,   364,
     156,   158,   165,   160,    44,     0,   359,   362,   274,   261,
     243,     0,     0,     0,     0,     0,   237,     0,     0,   235,
      52,    56,     0,     0,   375,   376,     0,   323,   220,   247,
     238,     0,   227,     0,   236,     0,     0,     0,     0,   377,
       0,   365,     0,     0,   230,   229,   226,   228,     0,     0,
       0,     0,     0,   219,   224,   231,   232,   233,   373,   374,
     378,   366,   234
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -404,  -404,  -404,   482,   412,   -42,     0,   285,    -5,  -404,
     359,  -404,   389,  -125,  -403,   130,   262,  -404,  -404,  -198,
    -223,   -32,     3,     4,  -404,  -404,  -404,  -404,  -404,  -404,
     -15,   -17,    33,  -404,  -404,  -404,   481,  -404,  -404,  -404,
     271,  -404,  -404,  -404,  -404,   376,  -404,   283,  -404,  -404,
    -404,  -404,   100,  -404,  -404,  -404,  -404,  -404,   140,  -404,
    -404,  -404,  -404,   -90,  -404,   379,  -404,  -404,  -404,  -404,
       5,    58,  -404,  -404,    62,  -192,  -404,  -404,  -404,  -404,
     499,  -404,    38,  -404,  -404,  -404,  -404,  -137,  -404,   164,
    -315,  -102,  -404,  -404,  -404,  -404,   196,  -404,  -404,  -404,
    -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,
     398,  -404,  -404,  -404,  -404,  -404,   141,  -404,  -132,  -404,
    -110,  -404,  -400,  -404,   288,   287,   290,   257,   286,  -404,
     254,  -404,   250,  -404,   274,  -404,   273,  -404,  -121,  -404,
    -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,
    -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -404,  -114,
    -404,  -404,  -404,  -252,   253,   145,  -404,   110,   113,  -404,
    -404,  -404
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    29,    30,    31,   112,    32,   114,    34,    96,   163,
      97,    98,   133,   261,   262,   263,   264,   265,   392,   451,
     364,    85,    86,    87,    37,    38,   138,   321,   180,    39,
     146,    40,    41,    42,    43,    44,    45,    46,    47,    48,
     268,    49,    50,   121,   162,   158,   159,   160,   161,    51,
      82,    52,    53,   117,   154,    54,    74,    55,    56,   119,
     156,    57,    78,   150,   151,   152,   153,   236,   375,   376,
     379,   380,   381,   382,   467,   266,    58,   111,    59,    60,
      61,    62,   123,   142,    64,   226,   227,   452,   229,   230,
     336,   337,   223,   442,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   436,   527,   528,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   220,
     221,   313,   182,   183,   184,   185,   186,   187,   188,   286,
     189,   291,   190,   294,   191,   297,   192,   301,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   270,   480,   222,   407,   360,    67,   372,   373,   550,
     134,   216
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      33,    99,   144,    35,    36,   228,   219,   179,   393,   140,
     483,    92,     1,    91,   435,     1,     1,   481,   485,   113,
     131,     1,   181,   132,     1,     1,   482,   363,   110,   155,
      33,    90,     1,    35,    36,     1,   100,    68,    63,    36,
     269,   231,   231,     8,    89,   231,   231,   253,   254,   256,
     249,   231,   271,   272,   273,   274,   275,   276,   143,   113,
      69,   181,    71,    72,   241,    88,   243,   391,    63,   400,
     141,    63,   430,   103,   128,   515,    70,    95,    95,    75,
      76,   361,    99,   362,   518,    28,    27,    84,    28,    28,
     125,   377,   102,   141,   127,    84,    84,    28,    28,   278,
      92,   361,    92,   362,   125,   232,    84,   287,   288,   449,
     233,   388,    93,   461,   547,     8,    89,   481,   371,   548,
      79,    80,   423,   269,   370,   424,   487,    73,   219,   128,
      92,    99,   235,   104,    92,  -183,   386,    92,   103,    92,
     136,    65,   225,   455,    77,    66,   453,   411,   454,   462,
     147,    83,   147,   463,   279,   115,    28,   409,   464,   409,
     409,   409,   409,   289,   290,   409,   104,   406,   404,   116,
     409,    65,   267,   409,   561,    66,   409,   118,   455,   234,
     420,   335,   124,   562,   147,    81,   425,   147,   394,   147,
     298,   395,   219,   365,   120,   257,   258,   166,   143,   299,
     300,   501,   441,   422,   378,   122,   538,   539,   540,   406,
     428,   129,   130,   167,   126,   168,   169,   148,   128,   148,
     396,   170,   514,   462,   259,   260,   139,   535,   366,   219,
     556,   314,   536,   137,   315,   316,   520,   563,   143,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   394,
     394,   148,   519,   537,   148,   267,   148,   149,   157,   149,
     171,   250,   251,   259,   260,   164,   172,   468,   173,   132,
     401,   476,   174,   477,   218,   175,   176,   284,   285,   177,
     178,   479,   317,   318,   181,   319,   181,   237,   181,   409,
     361,   149,   399,   238,   149,   239,   149,   335,   312,   489,
     490,   491,   165,   242,   166,   143,   -66,   -66,   -66,   -66,
     244,   181,   295,   296,   -66,   245,   -66,   503,   390,   258,
     167,   219,   168,   169,   105,   106,   107,   246,   170,   506,
      12,    13,    14,   108,    16,    17,   361,   277,   399,   281,
      28,   280,   219,   378,   378,   292,   293,   282,   371,   371,
     283,   479,   459,   460,   470,   471,   219,   510,   471,   468,
     231,   529,   225,   409,   320,   366,   368,   171,   181,   225,
     125,   517,   367,   172,   369,   173,   511,   471,   374,   174,
     465,   466,   175,   176,  -167,   383,   177,   178,   384,   437,
     532,   533,   541,   543,   387,   431,   398,   402,   403,   225,
     429,  -245,   401,  -246,   432,   438,   433,   439,   444,   445,
     554,   446,   447,   456,   558,   559,   560,   492,   469,   472,
     474,   549,   484,   565,   473,   566,   486,   488,   494,   493,
     322,   323,   166,   143,   495,   572,   496,   497,   509,   378,
     498,   499,   524,   504,   505,   530,   546,   570,   167,   516,
     168,   169,   521,   522,   225,   523,   170,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,   324,
     325,   326,   531,   327,   328,   329,   330,   331,   332,   333,
     334,    25,    26,   526,    99,   139,   534,   545,   551,   552,
     553,   172,   555,   173,   130,   564,   567,   174,   571,   568,
     175,   176,    94,   135,   177,   178,   165,     2,   166,   143,
     569,   544,   248,   217,   475,   109,   389,   397,   385,   513,
     240,   512,   101,   458,   167,   443,   168,   169,   247,   414,
     416,   417,   170,     3,     4,     5,     6,     7,     8,    89,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,   252,   408,   412,   418,   415,
     419,   413,   427,   508,     0,   507,     0,     0,   525,     0,
       0,     0,     0,     0,     0,     0,     0,   172,     0,   173,
       0,     0,     0,   174,     0,     0,   175,   176,     0,     0,
     177,   178,   165,     2,   166,   143,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     167,     0,   168,   169,     0,     0,     0,     0,   170,     3,
       4,     5,     6,     7,     8,    89,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,   322,   251,   166,   143,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   167,
       0,   168,   169,   172,     0,   173,     0,   170,     0,   174,
       0,     0,   175,   176,   434,     0,   177,   178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     324,   325,   326,     0,   327,   328,   329,   330,   331,   332,
     333,   334,    25,    26,     0,     0,   139,     0,     0,     0,
       0,     0,   172,   165,   173,   166,   143,     0,   174,     0,
       0,   175,   176,     0,     0,   177,   178,     0,     0,     0,
       0,   167,     0,   168,   169,   165,     0,   166,   143,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   167,     0,   168,   169,   165,     0,   166,
     143,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   167,     0,   168,   169,     0,
       0,     0,     0,   170,   172,   405,   173,     0,     0,     0,
     174,     0,     0,   175,   176,     0,     0,   177,   178,     0,
       0,     0,   410,     0,     0,     0,   172,     0,   173,     0,
       0,     0,   174,     0,     0,   175,   176,     0,     0,   177,
     178,     0,   421,     0,     0,     0,     0,     0,   172,   165,
     173,   166,   143,     0,   174,     0,     0,   175,   176,     0,
       0,   177,   178,     0,     0,     0,     2,   167,     0,   168,
     169,     0,     0,     0,   165,   170,   166,   143,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   167,     0,   168,   169,     0,     8,    89,    10,
     170,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,     0,     0,     0,     0,     0,     0,
     172,   426,   173,     0,     0,     0,   174,   145,     0,   175,
     176,     0,     0,   177,   178,     0,   440,     0,     0,     0,
       0,     0,     0,     0,     0,   172,   165,   173,   166,   143,
       0,   174,     0,     0,   175,   176,     0,     0,   177,   178,
       2,     0,     0,     0,   167,     0,   168,   169,   165,     0,
     166,   143,   170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   167,     0,   168,   169,
       0,     8,    89,    10,   170,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,     0,     0,
       0,     0,     0,     0,     0,     0,   448,   172,     0,   173,
       0,     0,     0,   174,     0,     0,   175,   176,     0,     0,
     177,   178,     0,     0,     0,     0,     0,     0,   500,   172,
     165,   173,   166,   143,     0,   174,     0,     0,   175,   176,
       0,     0,   177,   178,     0,     0,     0,     0,   167,     0,
     168,   169,     0,     0,     0,   165,   170,   166,   143,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   167,     0,   168,   169,     0,     0,     0,
       0,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   542,     0,     0,     0,     0,     0,     0,     0,
       0,   172,     0,   173,     0,     0,     0,   174,     0,     0,
     175,   176,     0,     0,   177,   178,     0,   557,     0,     0,
       0,     0,     0,     0,     0,     0,   172,   165,   173,   166,
     143,     0,   174,     0,     0,   175,   176,     0,     0,   177,
     178,     0,     0,     0,     0,   167,     0,   168,   169,   165,
       0,   166,   143,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   165,     0,   166,   143,     0,   168,
     169,     0,     0,     0,     0,   170,     0,     0,     0,     0,
       0,     0,     0,     0,   168,   169,     0,     0,     0,   165,
     170,   166,   143,     0,     0,     0,     0,     0,   172,     0,
     173,     0,     0,     0,   174,     0,     0,   175,   176,   168,
     169,   177,   178,     0,   478,   170,     0,     0,     0,     0,
     172,     0,   173,     0,     0,     0,   174,     0,     0,   175,
     176,     0,     0,   177,   178,   172,     0,   173,     0,     0,
       0,   174,     0,     0,   175,   176,     0,     0,   177,   178,
       1,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     255,     0,   173,     0,     0,     0,   174,     0,     0,   175,
     176,     0,     0,   177,   178,     0,     0,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,     1,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    25,    26,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,    28,     0,     0,     3,     4,     5,     6,
       7,     8,    89,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   361,     0,
     362,   450,    28,     0,     3,     4,     5,     6,     7,     8,
      89,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   361,     0,   399,   450,
      28,     0,     3,     4,     5,     6,     7,     8,    89,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,   224,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   502,     0,     0,
       0,     3,     4,     5,     6,     7,     8,    89,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,     2,     0,     0,   457,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     3,
       4,     5,     6,     7,     8,    89,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,     3,     4,     5,     6,     7,     8,    89,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24
};

static const yytype_int16 yycheck[] =
{
       0,    33,   116,     0,     0,   142,   138,   132,   260,   111,
     410,    28,     3,    28,   329,     3,     3,    66,   421,    61,
      64,     3,   132,    67,     3,     3,    75,   225,    45,   119,
      30,    28,     3,    30,    30,     3,    33,    64,     0,    35,
     172,     6,     6,    35,    36,     6,     6,   168,   169,   170,
     164,     6,   173,   174,   175,   176,   177,   178,     6,   101,
      46,   171,     3,     4,   154,    27,   156,   259,    30,   267,
     112,    33,   324,    35,    91,   478,    42,    65,    65,     3,
       4,    72,   114,    74,   484,    76,    74,    74,    76,    76,
      86,    70,    74,   135,    91,    74,    74,    76,    76,    22,
     117,    72,   119,    74,   100,    70,    74,    25,    26,   361,
      75,    75,     0,    74,    74,    35,    36,    66,   232,    74,
       3,     4,   314,   255,    72,   317,    75,    68,   260,   146,
     147,   163,   147,    72,   151,    74,   246,   154,   100,   156,
     102,     0,   142,   366,    68,     0,    72,   279,    74,    66,
     117,    36,   119,    70,    77,    74,    76,   278,    75,   280,
     281,   282,   283,    81,    82,   286,    72,   277,   270,    74,
     291,    30,   172,   294,    66,    30,   297,    68,   401,   146,
     301,   223,    75,    75,   151,    68,   318,   154,    66,   156,
      76,    69,   324,   225,    68,     3,     4,     5,     6,    85,
      86,   453,   334,   313,   236,    68,   521,   522,   523,   319,
     320,    65,    66,    21,    75,    23,    24,   117,   235,   119,
      67,    29,   474,    66,    71,    72,    68,    70,   225,   361,
     545,    20,    75,    73,    23,    24,   488,   552,     6,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    66,
      66,   151,    69,    69,   154,   255,   156,   117,     3,   119,
      68,     3,     4,    71,    72,    74,    74,   377,    76,    67,
     267,   396,    80,   398,    75,    83,    84,    18,    19,    87,
      88,   402,    71,    72,   394,    74,   396,    65,   398,   410,
      72,   151,    74,    65,   154,    69,   156,   339,    67,   431,
     432,   433,     3,    69,     5,     6,    64,    65,    66,    67,
      69,   421,    83,    84,    72,    66,    74,   454,     3,     4,
      21,   453,    23,    24,    39,    40,    41,    67,    29,   461,
      39,    40,    41,    42,    43,    44,    72,    74,    74,    78,
      76,    21,   474,   375,   376,    27,    28,    79,   462,   463,
      80,   472,     3,     4,    65,    66,   488,    65,    66,   469,
       6,   493,   362,   484,    66,   362,    66,    68,   478,   369,
     366,   481,    75,    74,    66,    76,    65,    66,    65,    80,
     375,   376,    83,    84,    70,    69,    87,    88,    69,     3,
     504,   505,   524,   525,    69,    74,    70,    75,    75,   399,
      73,    70,   399,    70,    74,    65,    74,    65,    70,    70,
     542,    70,    65,     3,   546,   547,   548,    57,    70,    75,
       7,   535,    70,   555,    73,   557,    73,     7,    65,    74,
       3,     4,     5,     6,    65,   567,    69,    73,    65,   471,
      75,    75,    74,    73,    73,    73,    65,   561,    21,    75,
      23,    24,    75,    75,   454,    75,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    75,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,   493,   526,    68,    75,    75,    65,    55,
      75,    74,    65,    76,    66,    65,    65,    80,    65,    75,
      83,    84,    30,   101,    87,    88,     3,     4,     5,     6,
      75,   526,   163,   134,   394,    44,   255,   265,   245,   471,
     151,   469,    33,   369,    21,   339,    23,    24,   162,   282,
     286,   291,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,   167,   278,   280,   294,   283,
     297,   281,   319,   463,    -1,   462,    -1,    -1,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    74,    -1,    76,
      -1,    -1,    -1,    80,    -1,    -1,    83,    84,    -1,    -1,
      87,    88,     3,     4,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    -1,    23,    24,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,     3,     4,     5,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    23,    24,    74,    -1,    76,    -1,    29,    -1,    80,
      -1,    -1,    83,    84,    36,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    74,     3,    76,     5,     6,    -1,    80,    -1,
      -1,    83,    84,    -1,    -1,    87,    88,    -1,    -1,    -1,
      -1,    21,    -1,    23,    24,     3,    -1,     5,     6,    29,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    23,    24,     3,    -1,     5,
       6,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    -1,    23,    24,    -1,
      -1,    -1,    -1,    29,    74,    75,    76,    -1,    -1,    -1,
      80,    -1,    -1,    83,    84,    -1,    -1,    87,    88,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    74,    -1,    76,    -1,
      -1,    -1,    80,    -1,    -1,    83,    84,    -1,    -1,    87,
      88,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,     3,
      76,     5,     6,    -1,    80,    -1,    -1,    83,    84,    -1,
      -1,    87,    88,    -1,    -1,    -1,     4,    21,    -1,    23,
      24,    -1,    -1,    -1,     3,    29,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    21,    -1,    23,    24,    -1,    35,    36,    37,
      29,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    75,    76,    -1,    -1,    -1,    80,    65,    -1,    83,
      84,    -1,    -1,    87,    88,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,     3,    76,     5,     6,
      -1,    80,    -1,    -1,    83,    84,    -1,    -1,    87,    88,
       4,    -1,    -1,    -1,    21,    -1,    23,    24,     3,    -1,
       5,     6,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,    23,    24,
      -1,    35,    36,    37,    29,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    73,    74,    -1,    76,
      -1,    -1,    -1,    80,    -1,    -1,    83,    84,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    73,    74,
       3,    76,     5,     6,    -1,    80,    -1,    -1,    83,    84,
      -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    21,    -1,
      23,    24,    -1,    -1,    -1,     3,    29,     5,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    23,    24,    -1,    -1,    -1,
      -1,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    76,    -1,    -1,    -1,    80,    -1,    -1,
      83,    84,    -1,    -1,    87,    88,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    74,     3,    76,     5,
       6,    -1,    80,    -1,    -1,    83,    84,    -1,    -1,    87,
      88,    -1,    -1,    -1,    -1,    21,    -1,    23,    24,     3,
      -1,     5,     6,    29,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,     5,     6,    -1,    23,
      24,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    -1,    -1,    -1,     3,
      29,     5,     6,    -1,    -1,    -1,    -1,    -1,    74,    -1,
      76,    -1,    -1,    -1,    80,    -1,    -1,    83,    84,    23,
      24,    87,    88,    -1,    68,    29,    -1,    -1,    -1,    -1,
      74,    -1,    76,    -1,    -1,    -1,    80,    -1,    -1,    83,
      84,    -1,    -1,    87,    88,    74,    -1,    76,    -1,    -1,
      -1,    80,    -1,    -1,    83,    84,    -1,    -1,    87,    88,
       3,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      74,    -1,    76,    -1,    -1,    -1,    80,    -1,    -1,    83,
      84,    -1,    -1,    87,    88,    -1,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,     3,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    76,    -1,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
      74,    75,    76,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,    74,    75,
      76,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,     3,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,     4,    -1,    -1,     7,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     3,     4,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    64,    65,    74,    76,    90,
      91,    92,    94,    95,    96,   111,   112,   113,   114,   118,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   130,
     131,   138,   140,   141,   144,   146,   147,   150,   165,   167,
     168,   169,   170,   171,   173,   205,   254,   255,    64,    46,
      42,     3,     4,    68,   145,     3,     4,    68,   151,     3,
       4,    68,   139,    36,    74,   110,   111,   112,   171,    36,
     111,   119,   120,     0,    92,    65,    97,    99,   100,   110,
     111,   169,    74,   171,    72,    96,    96,    96,    42,   125,
     120,   166,    93,    94,    95,    74,    74,   142,    68,   148,
      68,   132,    68,   171,    75,   112,    75,   111,   120,    65,
      66,    64,    67,   101,   259,    93,   171,    73,   115,    68,
     180,    94,   172,     6,   248,    65,   119,   121,   141,   147,
     152,   153,   154,   155,   143,   152,   149,     3,   134,   135,
     136,   137,   133,    98,    74,     3,     5,    21,    23,    24,
      29,    68,    74,    76,    80,    83,    84,    87,    88,   102,
     117,   209,   211,   212,   213,   214,   215,   216,   217,   219,
     221,   223,   225,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   260,   101,    75,   207,
     208,   209,   252,   181,     3,    95,   174,   175,   176,   177,
     178,     6,    70,    75,   121,   119,   156,    65,    65,    69,
     154,   152,    69,   152,    69,    66,    67,   134,    99,   248,
       3,     4,   199,   227,   227,    74,   227,     3,     4,    71,
      72,   102,   103,   104,   105,   106,   164,    95,   129,   207,
     250,   227,   227,   227,   227,   227,   227,    74,    22,    77,
      21,    78,    79,    80,    18,    19,   218,    25,    26,    81,
      82,   220,    27,    28,   222,    83,    84,   224,    76,    85,
      86,   226,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    67,   210,    20,    23,    24,    71,    72,    74,
      66,   116,     3,     4,    52,    53,    54,    56,    57,    58,
      59,    60,    61,    62,    63,    94,   179,   180,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     254,    72,    74,   108,   109,   110,   111,    75,    66,    66,
      72,   248,   256,   257,    65,   157,   158,    70,   110,   159,
     160,   161,   162,    69,    69,   136,   209,    69,    75,   129,
       3,   164,   107,   252,    66,    69,    67,   105,    70,    74,
     108,   111,    75,    75,   180,    75,   209,   253,   213,   227,
      70,   207,   214,   215,   216,   217,   219,   221,   223,   225,
     227,    68,   209,   164,   164,   207,    75,   253,   209,    73,
     252,    74,    74,    74,    36,   179,   192,     3,    65,    65,
      65,   207,   182,   185,    70,    70,    70,    65,    73,   252,
      75,   108,   176,    72,    74,   109,     3,     7,   178,     3,
       4,    74,    66,    70,    75,   159,   159,   163,   209,    70,
      65,    66,    75,    73,     7,   104,   102,   102,    68,   227,
     251,    66,    75,   211,    70,   103,    73,    75,     7,   207,
     207,   207,    57,    74,    65,    65,    69,    73,    75,    75,
      73,   252,    75,   176,    73,    73,   207,   257,   256,    65,
      65,    65,   163,   160,   252,   103,    75,   209,   211,    69,
     252,    75,    75,    75,    74,    65,    95,   193,   194,   207,
      73,    75,   248,   248,    75,    70,    75,    69,   179,   179,
     179,   207,    65,   207,    97,    75,    65,    74,    74,   248,
     258,    65,    55,    75,   207,    65,   179,    65,   207,   207,
     207,    66,    75,   179,    65,   207,   207,    65,    75,    75,
     248,    65,   207
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,    89,    90,    90,    91,    91,    92,    92,    92,    92,
      93,    93,    94,    94,    95,    96,    96,    96,    96,    96,
      96,    97,    98,    97,    99,   100,   100,   100,   100,   101,
     102,   102,   103,   103,   103,   103,   104,   104,   104,   105,
     105,   106,   106,   107,   107,   108,   108,   108,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   110,   110,   111,
     111,   111,   111,   112,   112,   112,   112,   113,   114,   115,
     116,   114,   117,   118,   118,   118,   118,   118,   118,   119,
     119,   120,   120,   121,   122,   122,   122,   122,   122,   122,
     122,   122,   123,   123,   123,   123,   123,   124,   124,   124,
     125,   125,   125,   125,   125,   125,   126,   127,   128,   129,
     129,   130,   130,   132,   131,   133,   131,   134,   134,   135,
     135,   136,   136,   137,   138,   139,   139,   140,   140,   142,
     141,   143,   141,   144,   145,   145,   146,   146,   148,   147,
     149,   147,   150,   151,   151,   152,   152,   153,   153,   154,
     154,   154,   154,   156,   155,   157,   155,   158,   155,   159,
     159,   160,   160,   161,   162,   162,   163,   164,   164,   166,
     165,   167,   168,   168,   168,   168,   169,   170,   170,   170,
     170,   172,   171,   173,   174,   174,   174,   175,   175,   176,
     176,   177,   177,   178,   178,   178,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   181,   182,
     180,   183,   183,   184,   184,   185,   185,   186,   186,   187,
     188,   189,   189,   189,   190,   192,   191,   193,   193,   193,
     193,   193,   193,   193,   193,   194,   194,   194,   195,   196,
     196,   196,   197,   197,   198,   199,   199,   200,   201,   202,
     203,   204,   205,   206,   206,   207,   208,   208,   209,   209,
     209,   209,   210,   210,   210,   210,   210,   210,   210,   210,
     210,   210,   210,   211,   211,   211,   212,   212,   213,   213,
     214,   214,   215,   215,   216,   216,   217,   217,   218,   218,
     219,   219,   220,   220,   220,   220,   221,   221,   222,   222,
     223,   223,   224,   224,   225,   225,   226,   226,   226,   227,
     227,   227,   227,   227,   227,   227,   227,   227,   227,   227,
     228,   229,   230,   230,   231,   232,   233,   234,   235,   235,
     236,   237,   238,   238,   238,   238,   238,   238,   238,   239,
     239,   240,   241,   242,   242,   243,   243,   244,   245,   246,
     247,   247,   247,   247,   248,   248,   249,   250,   251,   249,
     252,   253,   253,   254,   254,   254,   254,   255,   255,   255,
     256,   256,   256,   257,   257,   257,   258,   258,   258,   259,
     260
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     3,     2,     1,     1,     2,     1,     2,     1,
       2,     1,     0,     4,     1,     1,     2,     2,     3,     2,
       1,     3,     0,     1,     3,     2,     1,     3,     3,     2,
       3,     1,     2,     1,     3,     1,     2,     1,     3,     2,
       3,     3,     4,     2,     3,     3,     4,     1,     2,     1,
       2,     2,     3,     1,     3,     1,     1,     1,     3,     0,
       0,     6,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     0,     5,     0,     6,     1,     2,     1,
       3,     1,     3,     1,     2,     1,     1,     1,     1,     0,
       5,     0,     6,     2,     1,     1,     1,     1,     0,     5,
       0,     6,     2,     1,     1,     0,     1,     1,     2,     1,
       2,     2,     1,     0,     4,     0,     5,     0,     5,     1,
       3,     1,     1,     1,     2,     3,     1,     1,     1,     0,
       3,     1,     1,     2,     2,     3,     1,     1,     3,     2,
       4,     0,     5,     1,     0,     1,     1,     1,     3,     1,
       3,     1,     3,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     0,
       5,     0,     1,     1,     2,     1,     1,     1,     1,     7,
       5,     1,     1,     1,     7,     0,     6,     2,     3,     3,
       3,     4,     4,     4,     5,     1,     2,     1,     5,     2,
       2,     2,     2,     4,     1,     1,     1,     5,     2,     2,
       2,     3,     1,     2,     3,     1,     1,     3,     1,     1,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     4,     1,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     4,     6,     2,     2,     2,     2,     4,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     4,     3,     4,     2,     2,     4,
       1,     1,     1,     1,     1,     2,     3,     0,     0,     5,
       1,     1,     3,     5,     7,     9,    11,     1,     2,     2,
       0,     1,     3,     7,     7,     4,     0,     1,     3,     4,
       2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* top_level_declaration: declaration  */
#line 178 "./parse.y"
                { scope=0; reset(); common_comment=NULL; in_typedef=0; GetCurrentComment(); }
#line 2321 "y.tab.c"
    break;

  case 7: /* top_level_declaration: function_definition  */
#line 180 "./parse.y"
                { scope=0; reset(); common_comment=NULL; in_typedef=0; GetCurrentComment(); }
#line 2327 "y.tab.c"
    break;

  case 10: /* declaration_list: declaration  */
#line 189 "./parse.y"
                { scope=0; reset(); common_comment=NULL; in_typedef=0; }
#line 2333 "y.tab.c"
    break;

  case 11: /* declaration_list: declaration_list declaration  */
#line 191 "./parse.y"
                { scope=0; reset(); common_comment=NULL; in_typedef=0;
                  yyval=yyvsp[0]; }
#line 2340 "y.tab.c"
    break;

  case 12: /* declaration: declaration_specifiers initialized_declarator_list ';'  */
#line 197 "./parse.y"
                { in_type_spec=0; }
#line 2346 "y.tab.c"
    break;

  case 13: /* declaration: declaration_specifiers ';'  */
#line 199 "./parse.y"
                { in_type_spec=0; }
#line 2352 "y.tab.c"
    break;

  case 14: /* declaration_specifiers: declaration_specifiers1  */
#line 204 "./parse.y"
                { if(!in_structunion && !in_typedef && !in_function && !common_comment)
                  {common_comment=CopyString(GetCurrentComment()); SetCurrentComment(common_comment);} }
#line 2359 "y.tab.c"
    break;

  case 16: /* declaration_specifiers1: storage_class_specifier declaration_specifiers1  */
#line 211 "./parse.y"
                { if(yyvsp[-1]) yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); else yyval=yyvsp[0]; }
#line 2365 "y.tab.c"
    break;

  case 17: /* declaration_specifiers1: type_specifier  */
#line 213 "./parse.y"
                { if(!current->type) current->type=yyvsp[0]; }
#line 2371 "y.tab.c"
    break;

  case 18: /* declaration_specifiers1: type_specifier declaration_specifiers1  */
#line 215 "./parse.y"
                { if(!current->type) current->type=yyvsp[-1];
                  yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2378 "y.tab.c"
    break;

  case 20: /* declaration_specifiers1: type_qualifier declaration_specifiers1  */
#line 219 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2384 "y.tab.c"
    break;

  case 22: /* $@1: %empty  */
#line 226 "./parse.y"
                                          { in_type_spec=1; }
#line 2390 "y.tab.c"
    break;

  case 24: /* initialized_declarator: initialized_declarator1  */
#line 231 "./parse.y"
                {
                 if((in_function==0 || in_function==3) && !in_funcdef && !in_structunion)
                   {
                    char* specific_comment=GetCurrentComment();
                    if(!common_comment)   SetCurrentComment(specific_comment); else
                    if(!specific_comment) SetCurrentComment(common_comment);   else
                    if(strcmp(common_comment,specific_comment)) SetCurrentComment(ConcatStrings(3,common_comment," ",specific_comment)); else
                                          SetCurrentComment(common_comment);
                   }

                 if(in_typedef)
                   {
                    char* vname=strstr(yyvsp[0],current->name);
                    SeenTypedefName(current->name,vname[strlen(current->name)]=='('?-1:1);
                    if(!in_header)
                       SeenTypedef(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]));
                    if(in_function==3)
                       DownScope();
                   }
                 else if(in_function==2)
                    SeenFunctionArg(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]));
                 else
                   {
                    char* vname=strstr(yyvsp[0],current->name);
                    if(vname[strlen(current->name)]!='(' && IsATypeName(current->type)!='f')
                      {
                       if((in_funcbody==0 || scope&EXTERN_F) && !in_structunion && !(in_header==GLOBAL && scope&EXTERN_H))
                          SeenVariableDefinition(current->name,ConcatStrings(3,current->qual,current->type,yyvsp[0]),SCOPE);
                       else
                          if(in_funcbody)
                             SeenScopeVariable(current->name);
                      }
                    else
                       SeenFunctionProto(current->name,in_funcbody);
                    if(in_function==3)
                       DownScope();
                   }

                 if(in_function==3 && !in_structunion) in_function=0;
                }
#line 2435 "y.tab.c"
    break;

  case 46: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 322 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2441 "y.tab.c"
    break;

  case 48: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 328 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]);
                  { int i=0; while(yyvsp[-1][i] && yyvsp[-1][i]=='*') i++; if(!yyvsp[-1][i]) in_type_spec=0; } }
#line 2448 "y.tab.c"
    break;

  case 49: /* direct_abstract_declarator: '[' ']'  */
#line 331 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2454 "y.tab.c"
    break;

  case 50: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 333 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2460 "y.tab.c"
    break;

  case 51: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 335 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2466 "y.tab.c"
    break;

  case 52: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 337 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2472 "y.tab.c"
    break;

  case 53: /* direct_abstract_declarator: '(' ')'  */
#line 339 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2478 "y.tab.c"
    break;

  case 54: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 341 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2484 "y.tab.c"
    break;

  case 55: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 343 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2490 "y.tab.c"
    break;

  case 56: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 345 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2496 "y.tab.c"
    break;

  case 57: /* declarator: direct_declarator  */
#line 352 "./parse.y"
                { in_type_spec=0; }
#line 2502 "y.tab.c"
    break;

  case 58: /* declarator: pointer direct_declarator  */
#line 354 "./parse.y"
                { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2508 "y.tab.c"
    break;

  case 60: /* pointer: '*' type_qualifier_list  */
#line 360 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2514 "y.tab.c"
    break;

  case 61: /* pointer: '*' pointer  */
#line 362 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2520 "y.tab.c"
    break;

  case 62: /* pointer: '*' type_qualifier_list pointer  */
#line 364 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-2]," ",yyvsp[-1],yyvsp[0]); }
#line 2526 "y.tab.c"
    break;

  case 64: /* direct_declarator: '(' declarator ')'  */
#line 370 "./parse.y"
                { if(yyvsp[-1][0]=='*' && yyvsp[-1][1]==' ') { yyvsp[-1]=&yyvsp[-1][1]; yyvsp[-1][0]='*'; }
                  yyval=ConcatStrings(4," ",yyvsp[-2],yyvsp[-1],yyvsp[0]);
                }
#line 2534 "y.tab.c"
    break;

  case 67: /* simple_declarator: IDENTIFIER  */
#line 379 "./parse.y"
                { yyval=ConcatStrings(2," ",yyvsp[0]); current->name=yyvsp[0];
                  if(!current->type) current->type="int";
                  if(in_funcdef==1 && in_function!=3 && !in_structunion) SeenScopeVariable(yyvsp[0]); }
#line 2542 "y.tab.c"
    break;

  case 68: /* array_declarator: direct_declarator '[' ']'  */
#line 386 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2548 "y.tab.c"
    break;

  case 69: /* $@2: %empty  */
#line 387 "./parse.y"
                                { in_type_spec=0; }
#line 2554 "y.tab.c"
    break;

  case 70: /* $@3: %empty  */
#line 387 "./parse.y"
                                                                        { in_type_spec=1; }
#line 2560 "y.tab.c"
    break;

  case 71: /* array_declarator: direct_declarator '[' $@2 constant_expression $@3 ']'  */
#line 388 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-5],yyvsp[-4],yyvsp[-2],yyvsp[0]); }
#line 2566 "y.tab.c"
    break;

  case 73: /* storage_class_specifier: AUTO  */
#line 399 "./parse.y"
                { yyval=NULL; }
#line 2572 "y.tab.c"
    break;

  case 74: /* storage_class_specifier: EXTERN  */
#line 401 "./parse.y"
                { yyval=NULL;
                  if(in_funcbody) scope|=EXTERN_F;
                  else if(in_header) scope|=EXTERN_H;
                  else scope|=EXTERNAL; }
#line 2581 "y.tab.c"
    break;

  case 75: /* storage_class_specifier: REGISTER  */
#line 406 "./parse.y"
                { yyval=NULL; }
#line 2587 "y.tab.c"
    break;

  case 76: /* storage_class_specifier: STATIC  */
#line 408 "./parse.y"
                { yyval=NULL; scope |= LOCAL; }
#line 2593 "y.tab.c"
    break;

  case 77: /* storage_class_specifier: TYPEDEF  */
#line 410 "./parse.y"
                { yyval=NULL;
                  in_typedef=1; if(!in_header) SeenTypedef(NULL,NULL);
                  common_comment=CopyString(GetCurrentComment()); }
#line 2601 "y.tab.c"
    break;

  case 78: /* storage_class_specifier: INLINE  */
#line 414 "./parse.y"
                { yyval=NULL; scope |= INLINED; }
#line 2607 "y.tab.c"
    break;

  case 80: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 420 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2613 "y.tab.c"
    break;

  case 81: /* type_qualifier: CONST  */
#line 425 "./parse.y"
                { if(!current->type) current->qual=ConcatStrings(3,current->qual,yyvsp[0]," "); }
#line 2619 "y.tab.c"
    break;

  case 82: /* type_qualifier: VOLATILE  */
#line 427 "./parse.y"
                { if(!current->type) current->qual=ConcatStrings(3,current->qual,yyvsp[0]," "); }
#line 2625 "y.tab.c"
    break;

  case 83: /* type_specifier: type_specifier1  */
#line 434 "./parse.y"
                { in_type_spec=1; }
#line 2631 "y.tab.c"
    break;

  case 95: /* floating_type_specifier: DOUBLE LONG  */
#line 453 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2637 "y.tab.c"
    break;

  case 96: /* floating_type_specifier: LONG DOUBLE  */
#line 455 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2643 "y.tab.c"
    break;

  case 98: /* integer_type_specifier: integer_type_specifier_part type_qualifier  */
#line 461 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2649 "y.tab.c"
    break;

  case 99: /* integer_type_specifier: integer_type_specifier integer_type_specifier_part  */
#line 463 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2655 "y.tab.c"
    break;

  case 109: /* type_name: declaration_specifiers  */
#line 489 "./parse.y"
                { in_type_spec=0; }
#line 2661 "y.tab.c"
    break;

  case 110: /* type_name: declaration_specifiers abstract_declarator  */
#line 491 "./parse.y"
                { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2667 "y.tab.c"
    break;

  case 113: /* $@4: %empty  */
#line 503 "./parse.y"
                { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; }
#line 2679 "y.tab.c"
    break;

  case 114: /* enumeration_type_definition: ENUM '{' $@4 enumeration_definition_list '}'  */
#line 511 "./parse.y"
                { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2688 "y.tab.c"
    break;

  case 115: /* $@5: %empty  */
#line 516 "./parse.y"
                { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; }
#line 2700 "y.tab.c"
    break;

  case 116: /* enumeration_type_definition: ENUM enumeration_tag '{' $@5 enumeration_definition_list '}'  */
#line 524 "./parse.y"
                { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2709 "y.tab.c"
    break;

  case 120: /* enumeration_definition_list1: enumeration_definition_list1 ',' enumeration_constant_definition  */
#line 538 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2715 "y.tab.c"
    break;

  case 121: /* enumeration_constant_definition: enumeration_constant  */
#line 543 "./parse.y"
                { if(!in_header) SeenStructUnionComp(yyvsp[0],in_structunion); }
#line 2721 "y.tab.c"
    break;

  case 122: /* enumeration_constant_definition: enumeration_constant '=' assignment_expression  */
#line 545 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); if(!in_header) SeenStructUnionComp(yyvsp[-2],in_structunion); }
#line 2727 "y.tab.c"
    break;

  case 124: /* enumeration_type_reference: ENUM enumeration_tag  */
#line 554 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2733 "y.tab.c"
    break;

  case 129: /* $@6: %empty  */
#line 571 "./parse.y"
                { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; }
#line 2745 "y.tab.c"
    break;

  case 130: /* structure_type_definition: STRUCT '{' $@6 field_list '}'  */
#line 579 "./parse.y"
                { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2754 "y.tab.c"
    break;

  case 131: /* $@7: %empty  */
#line 584 "./parse.y"
                { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; }
#line 2766 "y.tab.c"
    break;

  case 132: /* structure_type_definition: STRUCT structure_tag '{' $@7 field_list '}'  */
#line 592 "./parse.y"
                { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2775 "y.tab.c"
    break;

  case 133: /* structure_type_reference: STRUCT structure_tag  */
#line 600 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2781 "y.tab.c"
    break;

  case 138: /* $@8: %empty  */
#line 617 "./parse.y"
                { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(yyvsp[-1],in_structunion);
                     else               SeenStructUnionStart(yyvsp[-1]);
                    }
                  in_structunion++; }
#line 2793 "y.tab.c"
    break;

  case 139: /* union_type_definition: UNION '{' $@8 field_list '}'  */
#line 625 "./parse.y"
                { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(2,yyvsp[-4]," {...}");
                  if(!in_header && !in_structunion && in_typedef) SeenStructUnionEnd();
                  yyval=ConcatStrings(5,yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2802 "y.tab.c"
    break;

  case 140: /* $@9: %empty  */
#line 630 "./parse.y"
                { push();
                  if(!in_header)
                    {
                     if(in_structunion) SeenStructUnionComp(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]),in_structunion);
                     else               SeenStructUnionStart(ConcatStrings(3,yyvsp[-2]," ",yyvsp[-1]));
                    }
                  in_structunion++; }
#line 2814 "y.tab.c"
    break;

  case 141: /* union_type_definition: UNION union_tag '{' $@9 field_list '}'  */
#line 638 "./parse.y"
                { pop(); in_structunion--;
                  if(!in_structunion && !current->type) current->type=ConcatStrings(3,yyvsp[-5]," ",yyvsp[-4]);
                  if(!in_header && !in_structunion) SeenStructUnionEnd();
                  yyval=ConcatStrings(7,yyvsp[-5]," ",yyvsp[-4]," ",yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2823 "y.tab.c"
    break;

  case 142: /* union_type_reference: UNION union_tag  */
#line 646 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2829 "y.tab.c"
    break;

  case 148: /* field_list1: field_list1 field_list2  */
#line 664 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2835 "y.tab.c"
    break;

  case 150: /* field_list2: structure_type_definition ';'  */
#line 670 "./parse.y"
                { yyval = ConcatStrings(3, yyvsp[-1], " ", yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(yyvsp[-1],in_structunion); }
#line 2842 "y.tab.c"
    break;

  case 151: /* field_list2: union_type_definition ';'  */
#line 673 "./parse.y"
                { yyval = ConcatStrings(3, yyvsp[-1], " ", yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(yyvsp[-1],in_structunion); }
#line 2849 "y.tab.c"
    break;

  case 153: /* $@10: %empty  */
#line 680 "./parse.y"
                { comp_type=yyvsp[0]; }
#line 2855 "y.tab.c"
    break;

  case 154: /* component_declaration: type_specifier $@10 component_declarator_list ';'  */
#line 682 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; }
#line 2861 "y.tab.c"
    break;

  case 155: /* $@11: %empty  */
#line 684 "./parse.y"
                { comp_type=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2867 "y.tab.c"
    break;

  case 156: /* component_declaration: type_qualifier_list type_specifier $@11 component_declarator_list ';'  */
#line 686 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; }
#line 2873 "y.tab.c"
    break;

  case 157: /* $@12: %empty  */
#line 688 "./parse.y"
                { comp_type=ConcatStrings(3,yyvsp[-1]," ",yyvsp[0]); }
#line 2879 "y.tab.c"
    break;

  case 158: /* component_declaration: type_specifier type_qualifier_list $@12 component_declarator_list ';'  */
#line 690 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); reset(); in_type_spec=0; }
#line 2885 "y.tab.c"
    break;

  case 159: /* component_declarator_list: component_declarator  */
#line 695 "./parse.y"
                { if(!in_header) SeenStructUnionComp(ConcatStrings(2,comp_type,yyvsp[0]),in_structunion); }
#line 2891 "y.tab.c"
    break;

  case 160: /* component_declarator_list: component_declarator_list ',' component_declarator  */
#line 697 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]);
                  if(!in_header) SeenStructUnionComp(ConcatStrings(2,comp_type,yyvsp[0]),in_structunion); }
#line 2898 "y.tab.c"
    break;

  case 163: /* simple_component: declarator  */
#line 708 "./parse.y"
                { if(in_function==2 && !in_structunion) { DownScope(); pop(); in_function=0; } }
#line 2904 "y.tab.c"
    break;

  case 164: /* bit_field: ':' width  */
#line 713 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2910 "y.tab.c"
    break;

  case 165: /* bit_field: declarator ':' width  */
#line 715 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 2916 "y.tab.c"
    break;

  case 169: /* $@13: %empty  */
#line 733 "./parse.y"
                { pop(); in_funcbody=1; in_function=0; }
#line 2922 "y.tab.c"
    break;

  case 170: /* function_definition: function_specifier $@13 compound_statement  */
#line 735 "./parse.y"
                { in_funcbody=in_function=0; DownScope(); SeenFunctionDefinition(NULL); }
#line 2928 "y.tab.c"
    break;

  case 171: /* function_specifier: function_specifier1  */
#line 740 "./parse.y"
                { char *func_type,*fname=strstr(yyvsp[0],(current-1)->name),*parenth=strstr(yyvsp[0],"(");
                  if(parenth>fname)
                     {parenth[0]=0;func_type=ConcatStrings(3,(current-1)->qual,(current-1)->type,yyvsp[0]);}
                  else
                    {
                     int open=1;
                     char *argbeg=strstr(&parenth[1],"("),*argend;
                     argbeg[1]=0;
                     for(argend=argbeg+2;*argend;argend++)
                       {
                        if(*argend=='(') open++;
                        if(*argend==')') open--;
                        if(!open) break;
                       }
                     func_type=ConcatStrings(4,(current-1)->qual,(current-1)->type,yyvsp[0],argend);
                    }
                  SeenFunctionDefinition(func_type);
                  common_comment=NULL;
                }
#line 2952 "y.tab.c"
    break;

  case 173: /* function_specifier1: declaration_specifiers function_declarator  */
#line 764 "./parse.y"
                { yyval=ConcatStrings(3,current->qual,current->type,yyvsp[0]); }
#line 2958 "y.tab.c"
    break;

  case 175: /* function_specifier1: declaration_specifiers function_declarator declaration_list  */
#line 767 "./parse.y"
                { yyval=ConcatStrings(3,current->qual,current->type,yyvsp[-1]); }
#line 2964 "y.tab.c"
    break;

  case 176: /* function_declarator: function_declarator0  */
#line 774 "./parse.y"
                { if(!in_structunion) { push(); in_function=2; } }
#line 2970 "y.tab.c"
    break;

  case 179: /* function_declarator0: pointer function_direct_declarator  */
#line 781 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 2976 "y.tab.c"
    break;

  case 180: /* function_declarator0: pointer '(' function_direct_declarator ')'  */
#line 783 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-3],yyvsp[-1]); }
#line 2982 "y.tab.c"
    break;

  case 181: /* $@14: %empty  */
#line 788 "./parse.y"
                { if(!in_structunion)
                  { push(); if(in_function==0) UpScope();
                    if(in_function==0 && !in_funcdef) in_function=1; if(in_function!=3) in_funcdef++; } }
#line 2990 "y.tab.c"
    break;

  case 182: /* function_direct_declarator: function_declarator1 '(' $@14 function_declarator2 ')'  */
#line 792 "./parse.y"
                { if(!in_structunion)
                    { pop();  if(in_function!=3) in_funcdef--; if(in_funcdef==0) in_function=3; }
                  yyval=ConcatStrings(4,yyvsp[-4],yyvsp[-3],yyvsp[-1],yyvsp[0]); }
#line 2998 "y.tab.c"
    break;

  case 183: /* function_declarator1: direct_declarator  */
#line 799 "./parse.y"
                {
                  if(!in_funcdef && !in_function && !in_funcbody && !in_structunion) SeenFunctionDeclaration(current->name,SCOPE);
                  in_type_spec=0;
                }
#line 3007 "y.tab.c"
    break;

  case 184: /* function_declarator2: %empty  */
#line 807 "./parse.y"
                { if(in_function==1 && in_funcdef==1 && !in_structunion) SeenFunctionArg("void","void");
                  if(in_structunion) yyval=NULL; else yyval="void"; }
#line 3014 "y.tab.c"
    break;

  case 187: /* identifier_list: IDENTIFIER  */
#line 815 "./parse.y"
                { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) { SeenFunctionArg(yyvsp[0],NULL); SeenScopeVariable(yyvsp[0]); } }
#line 3020 "y.tab.c"
    break;

  case 188: /* identifier_list: identifier_list ',' IDENTIFIER  */
#line 817 "./parse.y"
                { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) { SeenFunctionArg(yyvsp[0],NULL); SeenScopeVariable(yyvsp[0]); }
                  yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3027 "y.tab.c"
    break;

  case 190: /* parameter_type_list: parameter_list ',' ELLIPSES  */
#line 824 "./parse.y"
                { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) SeenFunctionArg(yyvsp[0],yyvsp[0]);
                  yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3034 "y.tab.c"
    break;

  case 191: /* parameter_list: parameter_declaration  */
#line 830 "./parse.y"
                { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) SeenFunctionArg(strcmp("void",yyvsp[0])?current->name:"void",yyvsp[0]);
                  in_type_spec=0; }
#line 3041 "y.tab.c"
    break;

  case 192: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 833 "./parse.y"
                { if(in_function==1 && in_funcdef==1 && in_funcbody==0 && !in_structunion) SeenFunctionArg(current->name,yyvsp[0]);
                  in_type_spec=0; yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3048 "y.tab.c"
    break;

  case 193: /* parameter_declaration: declaration_specifiers declarator  */
#line 839 "./parse.y"
                { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3054 "y.tab.c"
    break;

  case 194: /* parameter_declaration: declaration_specifiers  */
#line 841 "./parse.y"
                { in_type_spec=0; }
#line 3060 "y.tab.c"
    break;

  case 195: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 843 "./parse.y"
                { in_type_spec=0; yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3066 "y.tab.c"
    break;

  case 208: /* $@15: %empty  */
#line 867 "./parse.y"
                { UpScope(); reset(); }
#line 3072 "y.tab.c"
    break;

  case 209: /* $@16: %empty  */
#line 869 "./parse.y"
                { DownScope(); }
#line 3078 "y.tab.c"
    break;

  case 216: /* block_item: declaration  */
#line 886 "./parse.y"
                { scope=0; reset(); common_comment=NULL; in_typedef=0; }
#line 3084 "y.tab.c"
    break;

  case 225: /* $@17: %empty  */
#line 918 "./parse.y"
               { UpScope(); reset(); }
#line 3090 "y.tab.c"
    break;

  case 226: /* for_statement: FOR $@17 '(' for_expressions ')' statement  */
#line 920 "./parse.y"
                { DownScope(); }
#line 3096 "y.tab.c"
    break;

  case 236: /* for_expression_or_declaration: declaration_specifiers initialized_declarator_list  */
#line 937 "./parse.y"
                { in_type_spec=0; }
#line 3102 "y.tab.c"
    break;

  case 237: /* for_expression_or_declaration: declaration_specifiers  */
#line 939 "./parse.y"
                { in_type_spec=0; }
#line 3108 "y.tab.c"
    break;

  case 257: /* comma_expression: comma_expression ',' assignment_expression  */
#line 1012 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3114 "y.tab.c"
    break;

  case 274: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 1043 "./parse.y"
                { yyval=ConcatStrings(5,yyvsp[-4],yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3120 "y.tab.c"
    break;

  case 275: /* conditional_expression: logical_or_expression '?' ':' conditional_expression  */
#line 1045 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3126 "y.tab.c"
    break;

  case 277: /* logical_or_expression: logical_or_expression OR_OP logical_and_expression  */
#line 1053 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3132 "y.tab.c"
    break;

  case 279: /* logical_and_expression: logical_and_expression AND_OP bitwise_or_expression  */
#line 1061 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3138 "y.tab.c"
    break;

  case 281: /* bitwise_or_expression: bitwise_or_expression '|' bitwise_xor_expression  */
#line 1069 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3144 "y.tab.c"
    break;

  case 283: /* bitwise_xor_expression: bitwise_xor_expression '^' bitwise_and_expression  */
#line 1077 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3150 "y.tab.c"
    break;

  case 285: /* bitwise_and_expression: bitwise_and_expression '&' equality_expression  */
#line 1085 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3156 "y.tab.c"
    break;

  case 287: /* equality_expression: equality_expression equality_op relational_expression  */
#line 1093 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3162 "y.tab.c"
    break;

  case 291: /* relational_expression: relational_expression relational_op shift_expression  */
#line 1106 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3168 "y.tab.c"
    break;

  case 297: /* shift_expression: shift_expression shift_op additive_expression  */
#line 1121 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3174 "y.tab.c"
    break;

  case 301: /* additive_expression: additive_expression add_op multiplicative_expression  */
#line 1134 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3180 "y.tab.c"
    break;

  case 305: /* multiplicative_expression: multiplicative_expression mult_op unary_expression  */
#line 1147 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3186 "y.tab.c"
    break;

  case 321: /* bitwise_negation_expression: '~' unary_expression  */
#line 1178 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3192 "y.tab.c"
    break;

  case 322: /* cast_expression: '(' type_name ')' unary_expression  */
#line 1183 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3198 "y.tab.c"
    break;

  case 325: /* logical_negation_expression: '!' unary_expression  */
#line 1193 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3204 "y.tab.c"
    break;

  case 328: /* sizeof_expression: SIZEOF '(' type_name ')'  */
#line 1206 "./parse.y"
                { yyval=ConcatStrings(4,yyvsp[-3],yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3210 "y.tab.c"
    break;

  case 329: /* sizeof_expression: SIZEOF unary_expression  */
#line 1208 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3216 "y.tab.c"
    break;

  case 330: /* unary_minus_expression: '-' unary_expression  */
#line 1213 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3222 "y.tab.c"
    break;

  case 331: /* unary_plus_expression: '+' unary_expression  */
#line 1218 "./parse.y"
                { yyval=ConcatStrings(2,yyvsp[-1],yyvsp[0]); }
#line 3228 "y.tab.c"
    break;

  case 334: /* postfix_expression: function_call_direct  */
#line 1227 "./parse.y"
                { if(!IsAScopeVariable(yyvsp[0])) SeenFunctionCall(yyvsp[0]); }
#line 3234 "y.tab.c"
    break;

  case 350: /* primary_expression: name  */
#line 1271 "./parse.y"
                { CheckFunctionVariableRef(yyvsp[0],in_funcbody); }
#line 3240 "y.tab.c"
    break;

  case 356: /* parenthesized_expression: '(' expression ')'  */
#line 1284 "./parse.y"
                { yyval=ConcatStrings(3,yyvsp[-2],yyvsp[-1],yyvsp[0]); }
#line 3246 "y.tab.c"
    break;

  case 357: /* $@18: %empty  */
#line 1285 "./parse.y"
              { push(); }
#line 3252 "y.tab.c"
    break;

  case 358: /* $@19: %empty  */
#line 1285 "./parse.y"
                                             { pop(); }
#line 3258 "y.tab.c"
    break;


#line 3262 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1344 "./parse.y"


#if YYDEBUG

static int   last_yylex[11];
static char *last_yylval[11];
static int count=0,modcount=0;

#endif /* YYDEBUG */


 /*++++++++++++++++++++++++++++++++++++++
  Stop parsing the current file, due to an error.

  char *s The error message to print out.
  ++++++++++++++++++++++++++++++++++++++*/

static void yyerror( const char *s )
{
#if YYDEBUG
 int i;
#endif

 fflush(stdout);
 fprintf(stderr,"%s:%d: cxref: %s\n\n",parse_file,parse_line,s);

#if YYDEBUG

 fprintf(stderr,"The previous 10, current and next 10 symbols are:\n");

 for(i=count>10?count-11:0,modcount=i%11;i<count-1;i++,modcount=i%11)
#ifdef YYBISON
    fprintf(stderr,"%3d | %3d : %16s : %s\n",i+1-count,last_yylex[modcount],yytname[YYTRANSLATE(last_yylex[modcount])],last_yylval[modcount]);
#else
    fprintf(stderr,"%3d | %3d : %s\n",i+1-count,last_yylex[modcount],last_yylval[modcount]);
#endif

#ifdef YYBISON
 fprintf(stderr,"  0 | %3d : %16s : %s\n",yychar,yytname[YYTRANSLATE(yychar)],yylval);
#else
 fprintf(stderr,"  0 | %3d : %s\n",yychar,yylval);
#endif

 for(i=0;i<10;i++)
   {
    yychar=yylex();
    if(!yychar)
      {fprintf(stderr,"END OF FILE\n");break;}
#ifdef YYBISON
    fprintf(stderr,"%3d | %3d : %16s : %s\n",i+1,yychar,yytname[YYTRANSLATE(yychar)],yylval);
#else
    fprintf(stderr,"%3d | %3d : %s\n",i+1,yychar,yylval);
#endif
   }

 fprintf(stderr,"\n");

#endif /* YYDEBUG */

 /* Finish off the input. */

#undef yylex

 if(yychar)
    while((yychar=yylex()));
}


 /*++++++++++++++++++++++++++++++++++++++
  Call the lexer, the feedback from the parser to the lexer is applied here.

  int cxref_yylex Returns the value from the lexer, modified due to parser feedback.
  ++++++++++++++++++++++++++++++++++++++*/

static int cxref_yylex(void)
{
 static int last_yyl=0;
 int yyl=yylex();

 if(yyl==TYPE_NAME)
    if(in_type_spec || (in_structunion && last_yyl=='}') || last_yyl==TYPE_NAME ||
       last_yyl==GOTO ||
       last_yyl==CHAR || last_yyl==SHORT || last_yyl==INT || last_yyl==LONG ||
       last_yyl==SIGNED || last_yyl==UNSIGNED ||
       last_yyl==FLOAT || last_yyl==DOUBLE || last_yyl==FLOAT_EXTENSION ||
       last_yyl==BOOL)
       yyl=IDENTIFIER;

 last_yyl=yyl;

#if YYDEBUG

 last_yylex [modcount]=yyl;
 last_yylval[modcount]=yylval;

 if(yyl)
   {
    count++;
    modcount=count%11;
   }
 else
   {
    count=0;
    modcount=0;
   }

#if YYDEBUG == 2

 if(yyl)
#ifdef YYBISON
    printf("#parse.y# %6d | %16s:%4d | %3d : %16s : %s\n",count,parse_file,parse_line,yyl,yytname[YYTRANSLATE(yyl)],yylval);
#else
    printf("#parse.y# %6d | %16s:%4d | %3d : %s\n",count,parse_file,parse_line,yyl,yylval);
#endif /* YYBISON */
 else
    printf("#parse.y# %6d | %16s:%4d | END OF FILE\n",count,parse_file,parse_line);

 fflush(stdout);

#endif /* YYDEBUG==2 */

#endif /* YYDEBUG */

 return(yyl);
}
